<template>
  <div>
    <el-form-item label="">
      <div class="upload_video" id="upload_video">
<!--        <el-upload-->
<!--          class="upload-demo"-->
<!--          ref="upload"-->
<!--          action="#"-->
<!--          :http-request="uploadVideoToTxPcdn"-->
<!--          accept=".mp4"-->
<!--          :limit="1"-->
<!--          :on-remove="handleRemove"-->
<!--          :on-change="handleChange"-->
<!--          :auto-upload="false"-->
<!--          :key="uploadKey"-->
<!--        >-->
<!--          <el-button slot="trigger" size="small" type="primary" >选取视频</el-button>-->
<!--          <el-button style="margin-left: 10px;" size="small" type="success" @click="submitUpload">点击上传</el-button>-->
          <!-- 仅当showControl为true时显示视频库选取按钮 -->
          <el-button v-if="showControl" style="margin-left: 10px;" size="small" type="success" @click="openVideoLibrary">视频库选取</el-button>
<!--          &lt;!&ndash; 线路一 &ndash;&gt;-->
<!--          <div class="progress-container">-->
<!--            <span class="progress-label">线路一</span>-->
<!--            <el-progress-->
<!--              style="margin-top: 5px;"-->
<!--              class="progress"-->
<!--              :text-inside="true"-->
<!--              :stroke-width="18"-->
<!--              :percentage="txProgress"-->
<!--              status="success">-->
<!--            </el-progress>-->
<!--          </div>-->

          <!-- 线路二 -->
<!--          <div class="progress-container">-->
<!--            <span class="progress-label">线路二</span>-->
<!--            <el-progress-->
<!--              style="margin-top: 5px;"-->
<!--              class="progress"-->
<!--              :text-inside="true"-->
<!--              :stroke-width="18"-->
<!--              :percentage="hwProgress"-->
<!--              status="success">-->
<!--            </el-progress>-->
<!--          </div>-->
          <div slot="tip" class="el-upload__tip">只能上传mp4文件，且不超过500M</div>
<!--        </el-upload>-->
      </div>
    </el-form-item>
    <el-form-item label="视频播放">
      <video v-if="videoUrl.endsWith('mp4')" ref="myvideo" :src="videoUrl" id="video" width="100%" height="300px" controls></video>
      <video v-if="videoUrl.endsWith('m3u8')" ref="myM3u8Video" :src="videoUrl" id="meu8Video" width="100%" height="300px" controls type="application/x-mpegURL"></video>
      <div v-if="fileName">视频文件名: {{ fileName }}</div>
      <div v-if="fileKey">文件Key: {{ fileKey }}</div>
      <div v-if="fileSize">文件大小(MB): {{ (fileSize / (1024 * 1024)).toFixed(2) }} MB</div>
    </el-form-item>
    <!-- 仅当showControl为true时显示播放线路选择器 -->
<!--    <el-form-item v-if="showControl" label="播放线路">-->
<!--      <el-radio-group v-model="localUploadType">-->
<!--        <el-radio :label="1" >线路一</el-radio>-->
<!--&lt;!&ndash;        <el-radio :label="2" >线路二</el-radio>&ndash;&gt;-->
<!--        &lt;!&ndash;        <el-radio :label="3" >线路三</el-radio>&ndash;&gt;-->
<!--      </el-radio-group>-->
<!--    </el-form-item>-->

    <!-- 视频库选择对话框 -->
    <el-dialog title="视频库选择" :visible.sync="libraryOpen" width="900px" append-to-body>
      <!-- 搜索条件 -->
      <el-form :inline="true" :model="libraryQueryParams" class="library-search">
        <el-form-item label="素材名称">
          <el-input
            v-model="libraryQueryParams.remark"
            placeholder="请输入素材名称"
            clearable
            size="small"
            @keyup.enter.native="handleLibraryQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleLibraryQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetLibraryQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <!-- 视频列表 -->
      <el-table v-loading="libraryLoading" :data="libraryList" @row-click="handleLibrarySelect" highlight-current-row>
        <el-table-column label="素材名称" align="center" prop="remark" />
<!--        <el-table-column label="缩略图" align="center">-->
<!--          <template slot-scope="scope">-->
<!--            <video-->
<!--              :src="scope.row.videoUrl"-->
<!--              controls-->
<!--              controlsList="nodownload"-->
<!--              class="video-player"-->
<!--              @contextmenu.prevent-->
<!--            ></video>-->
<!--          </template>-->
<!--        </el-table-column>-->
        <el-table-column label="视频时长" align="center">
          <template slot-scope="scope">
            <span>{{ formatDuration(scope.row.duration) }}</span>
          </template>
        </el-table-column>
      </el-table>

      <!-- 分页 -->
      <pagination
        v-show="libraryTotal>0"
        :total="libraryTotal"
        :page.sync="libraryQueryParams.pageNum"
        :limit.sync="libraryQueryParams.pageSize"
        @pagination="getList"
      />

      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="confirmVideoSelection">确 定</el-button>
        <el-button @click="cancelVideoSelection">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { uploadObject } from "@/utils/cos.js";
import Pagination from "@/components/Pagination";
// import { listVideoResource } from '@/api/course/videoResource';
import { listLiveVideo, getLiveVideo, delLiveVideo, addLiveVideo, updateLiveVideo, exportLiveVideo } from "@/api/live/liveVideo";
import Hls from 'hls.js';
import Vue from "vue";
export default {
  components: {
    Pagination
  },
  props: {
    videoUrl: {
      type: String,
      default: "",
    },
    fileKey: {
      type: String,
      default: "",
    },
    fileSize: {
      type: Number,
      default: null,
    },
    fileName: {
      type: String,
      default: "",
    },
    line_1: {
      type: String,
      default: "",
    },
    line_2: {
      type: String,
      default: "",
    },
    line_3: {
      type: String,
      default: "",
    },
    thumbnail: {
      type: String,
      default: "",
    },
    uploadType: {
      type: Number,
      default: null,
    },
    type: {
      type: Number,
      default: null,
    },
    isPrivate: {
      type: Number,
      default: 0,
    },

    // 使用一个变量控制显示，默认为true显示所有控制项
    showControl: {
      type: Boolean,
      default: true,
    }
  },
  destroyed() {
    this.hls?.destroy();
  },
  data() {
    return {
      videoName:'',
      isHidden : false,
      localUploadType: this.uploadType,
      duration: 0,
      fileId: "",
      uploadTypeOptions: [
        { dictLabel: "线路一", dictValue: 1 }, // 腾讯pcdn
        { dictLabel: "线路二", dictValue: 2 }, // 华为云obs
        // { dictLabel: "华为云VOD", dictValue: 4 },
        // { dictLabel: "腾讯云VOD", dictValue: 5 },
      ],
      fileList: [],
      txProgress: 0,
      hwProgress: 0,
      uploadLoading: false,
      uploadKey: 0,
      // 视频库选择相关数据
      libraryOpen: false,
      libraryLoading: false,
      libraryTotal: 0,
      libraryList: [],
      selectedVideo: null,
      hls:null,
      libraryQueryParams: {
        pageNum: 1,
        pageSize: 10,
        resourceName: null,
        liveId: -1,
        videoUrl: null,
        videoType: -1,
        sort: null,
        remark: null,
        finishStatus:1
      },
      liveQueryParams: {
        pageNum: 1,
        pageSize: 10,
        liveId: -1,
        videoUrl: null,
        videoType: -1,
        sort: null,
        remark: null,
      },
    };
  },
  mounted() {
    this.reset();
    if (this.videoUrl.endsWith(".m3u8")) {
      this.$nextTick(() => {
        this.initPlayer()
      })
    }
  },
  watch: {
    videoUrl(newVal,oldVal){
      console.log("触发数据改变")
      if (this.videoUrl.endsWith(".m3u8")) {
        this.$nextTick(() => {
          this.initPlayer()
        })
      }
    },
    uploadType(newType) {
      this.localUploadType = newType;
    },

  },
  methods: {
    initPlayer() {
      this.hls?.destroy();
      if (Hls.isSupported()) {
        const videoElement = this.$refs.myM3u8Video
        if (!videoElement) {
          console.error('找不到 video 元素')
          return
        }
        this.hls = new Hls();
        this.hls.attachMedia(videoElement);
        this.hls.on(Hls.Events.MEDIA_ATTACHED, () => {
          this.hls.loadSource(this.videoUrl);
          this.hls.on(Hls.Events.STREAM_LOADED, (event, data) => {
            videoElement.play();
          });
        });
        this.hls.on(Hls.Events.ERROR, (event, data) => {
          console.error('HLS 错误:', data);
        });
      } else {
        console.error('浏览器不支持 HLS')
      }
    },
    /** 查询直播视频列表 */
    getList() {
      this.libraryLoading = true;
      listLiveVideo(this.libraryQueryParams).then(response => {
        this.libraryList = response.rows;
        this.libraryTotal = response.total;
        this.libraryLoading = false;
      });
    },
    // 打开视频库对话框
    openVideoLibrary() {
      this.libraryOpen = true;
      this.selectedVideo = null;
      this.getList();
    },
    handleChange(file, fileList) {
      this.fileList = fileList;
      this.getVideoDuration(file.raw);
    },
    getVideoDuration(file) {
      const video = document.createElement("video");
      video.preload = "metadata";
      video.onloadedmetadata = () => {
        window.URL.revokeObjectURL(video.src);
        this.duration = parseInt(video.duration.toFixed(2));
        console.log("视频时长=========>",this.duration);
        this.$emit("video-duration", this.duration);
        console.log("文件大小=====>",file.size);
        this.$emit("update:fileSize", file.size);
      };
      video.src = URL.createObjectURL(file);
    },
    async submitUpload() {
      if (this.fileList.length < 1) {
        return this.$message.error("请先选取视频，再进行上传");
      }
      //同时上传个线路
      await this.uploadVideoToTxPcdn();
      this.$emit("update:fileName", this.fileList[0].name);
    },
    //获取第一帧封面
    async getFirstThumbnail(){
      const file = this.fileList[0].raw;
      getThumbnail(file).then(response => {
        console.log("获取到第一帧为封面======>",response.url)
        this.$emit("update:thumbnail", response.url);
      })
    },
    //更新华为线路进度条
    // updateHwProgress(progress) {
    //   this.hwProgress = progress;
    // },
    //更新腾讯线路进度条
    updateTxProgress(progressData) {
      this.txProgress = Math.round(progressData.percent * 100);
    },
    //上传腾讯云Pcdn
    async uploadVideoToTxPcdn() {
      try {
        const file = this.fileList[0].raw;
        const data = await uploadObject(file, this.updateTxProgress,this.type);
        console.log("腾讯COS返回========>",data);
        console.log("isPrivate=======>",this.isPrivate)
        let line_1='' ;
        if (this.isPrivate===0){
          line_1 = `${ Vue.prototype.$runtimeConfig.VUE_APP_VIDEO_LINE_1}${data.urlPath}`;
        }else {
          line_1 = `${ Vue.prototype.$runtimeConfig.VUE_APP_VIDEO_LINE_1}${data.urlPath}`;
        }
        line_1 = line_1.replace(/\.mp4$/, '.m3u8');

        let urlPathWithoutFirstSlash = data.urlPath.substring(1);
        this.$emit("update:fileKey", urlPathWithoutFirstSlash);

        console.log("文件key",urlPathWithoutFirstSlash);
        console.log("组装URL========>",line_1);
        this.$emit("update:videoUrl", line_1);
        this.$emit("update:line_1", line_1);
        this.$emit("change", line_1,line_1);
        // this.$emit("update:line_2", line_2);
        this.$message.success("线路一上传成功");
      } catch (error) {
        this.$message.error("线路一上传失败");
      }
    },
    //上传华为云Obs
    async uploadVideoToHwObs() {
      try {
        const file = this.fileList[0].raw;
        const data = await uploadToOBS(file, this.updateHwProgress,this.type);
        console.log("华为OBS返回========>",data);
        let line_2='' ;
        if (this.isPrivate===0){
          line_2 = `${Vue.prototype.$runtimeConfig.VUE_APP_VIDEO_LINE_2}/${data.urlPath}`;
        }else {
          line_2 = `${Vue.prototype.$runtimeConfig.VUE_APP_VIDEO_LINE_2}/${data.urlPath}`;
        }
        // this.$emit("update:videoUrl", data);
        this.$emit("update:line_2", line_2);
        this.$message.success("线路二上传成功");
      } catch (error) {
        this.$message.error("线路二上传失败");
      }
    },
    handleRemove(file, fileList) {
      console.log(file, fileList.length);
    },
    reset() {
      // 重置内部状态
      this.txProgress = 0;
      this.fileList = [];
      // this.$refs.upload.clearFiles();
      this.uploadKey++;
    },
    /** 查询视频库列表 */
    getLibraryList() {
      this.libraryLoading = true;
      // listVideoResource(this.libraryQueryParams).then(response => {
      //   this.libraryList = response.rows;
      //   this.libraryTotal = response.total;
      //   this.libraryLoading = false;
      // });
    },
    /** 搜索视频库按钮操作 */
    handleLibraryQuery() {
      this.libraryQueryParams.pageNum = 1;
      this.getList();
    },
    /** 重置视频库查询按钮操作 */
    resetLibraryQuery() {
      this.libraryQueryParams = {
        pageNum: 1,
        pageSize: 10,
        resourceName: null,
        liveId: -1,
        videoUrl: null,
        videoType: -1,
        sort: null,
        remark: null,
        finishStatus:1
      };
      this.handleLibraryQuery();
    },
    /** 视频库选择行点击 */
    handleLibrarySelect(row) {
      this.selectedVideo = row;
    },
    /** 格式化视频时长 */
    formatDuration(seconds) {
      if (!seconds) return '00:00';

      const minutes = Math.floor(seconds / 60);
      const remainingSeconds = seconds % 60;

      return `${minutes.toString().padStart(2, '0')}:${remainingSeconds.toString().padStart(2, '0')}`;
    },
    /** 确认选择视频 */
    confirmVideoSelection() {
      if (!this.selectedVideo) {
        this.$message.warning("请选择一个视频");
        return;
      }
      console.log("confirmVideoSelection")
      console.log(this.selectedVideo)

      // 更新组件内部数据
      this.$emit("update:fileName", this.selectedVideo.fileName);
      this.$emit("update:line_1", this.selectedVideo.lineOne);
      this.$emit("update:fileSize", this.selectedVideo.fileSize);
      this.$emit("update:fileKey", this.selectedVideo.fileKey);
      this.$emit("video-duration", this.selectedVideo.duration);
      // 设置预览URL
      this.$emit("update:videoUrl", this.selectedVideo.videoUrl);
      this.$emit("change", this.selectedVideo.videoUrl,this.selectedVideo.lineOne);

      if (this.videoUrl.endsWith(".m3u8")) {
        this.$nextTick(() => {
          this.initPlayer()
        })
      }
      this.libraryOpen = false;
    },
    /** 取消视频选择 */
    cancelVideoSelection() {
      this.libraryOpen = false;
      this.selectedVideo = null;
    }
  }
};
</script>

<style>
.progress-container {
  margin-bottom: 5px; /* 进度条之间的间距 */
}

.progress-label {
  display: block;
  font-weight: bold;
  font-size: 13px;
  color: #303331; /* 标签颜色，可以根据需要调整 */
}

/* 视频库选择对话框样式 */
.library-search {
  margin-bottom: 15px;
}

.el-table .el-table__row:hover {
  cursor: pointer;
}
</style>
